# 2020-10-27 Triage Log

Relatively quiet week for performance.

Triage done by **@simulacrum**.
Revision range: [22e6b9c68941996daa45786b4145e6196e51f0f4..824f900a96d752da2d882863c65f9736e5f2b347](https://perf.rust-lang.org/?start=22e6b9c68941996daa45786b4145e6196e51f0f4&end=824f900a96d752da2d882863c65f9736e5f2b347&absolute=false&stat=instructions%3Au)

0 Regressions, 2 Improvements, 3 Mixed
1 in rollups.

#### Regressions

Some mixed results, but no PRs with solely regressions this week.

#### Improvements

[#78077](https://github.com/rust-lang/rust/issues/78077)
- Very large improvement in [instruction counts](https://perf.rust-lang.org/compare.html?start=1d2726726f8f3128e98191e4c6cb94bd76d0ddd4&end=1eaadebb3dee31669c7649b32747381d11614fae&stat=instructions:u) (up to -9.9% on `incr-full` builds of `deeply-nested-async-check`)

[#77476](https://github.com/rust-lang/rust/issues/77476)
- Large improvement in [instruction counts](https://perf.rust-lang.org/compare.html?start=3e0dd24a6c0812eedbb02182a75c352f8a7e184a&end=5171cc76c264fd46f32e140c2e460c77ca87d5e5&stat=instructions:u) (up to -6.2% on `incr-full` builds of `clap-rs-check`)
- Interesting case where instruction counts show major improvement across the
  board, but wall times are either a slight regression or largely unchanged
  (within noise bound).

#### Mixed

[#78334](https://github.com/rust-lang/rust/issues/78334)
- Moderate improvement in [instruction counts](https://perf.rust-lang.org/compare.html?start=ffa2e7ae8fbf9badc035740db949b9dae271c29f&end=f58ffc93815f76576eb56df4bdeec2fe8f12b766&stat=instructions:u) (up to -1.5% on `full` builds of `match-stress-enum-check`)
- Moderate regression in [instruction counts](https://perf.rust-lang.org/compare.html?start=ffa2e7ae8fbf9badc035740db949b9dae271c29f&end=f58ffc93815f76576eb56df4bdeec2fe8f12b766&stat=instructions:u) (up to 1.2% on `full` builds of `unicode_normalization-check`)
- Unclear as to causes, left nag; will folow-up in a future week.

[#77187](https://github.com/rust-lang/rust/issues/77187)
- Moderate regression in [instruction counts](https://perf.rust-lang.org/compare.html?start=0da6d42f297642a60f2640ec313b879b376b9ad8&end=fd542592f08ca0d1f7255600115c2eafdf6b5da7&stat=instructions:u) (up to 2.9% on `full` builds of `regression-31157-debug`)
- Moderate improvement in [instruction counts](https://perf.rust-lang.org/compare.html?start=0da6d42f297642a60f2640ec313b879b376b9ad8&end=fd542592f08ca0d1f7255600115c2eafdf6b5da7&stat=instructions:u) (up to -1.1% on `incr-patched: b9b3e592dd cherry picked` builds of `style-servo-debug`)
- Roughly neutral (or an improvement) on wall times; and a long-desired change.
  Not proposing a revert at this time.

[#77876](https://github.com/rust-lang/rust/issues/77876)
- Large improvement in [instruction counts](https://perf.rust-lang.org/compare.html?start=fd542592f08ca0d1f7255600115c2eafdf6b5da7&end=a4d30a7b490065f0aa56f58e508a11546445aea9&stat=instructions:u) (up to -8.1% on `full` builds of `ctfe-stress-4-check`)
- Moderate regression in [instruction counts](https://perf.rust-lang.org/compare.html?start=fd542592f08ca0d1f7255600115c2eafdf6b5da7&end=a4d30a7b490065f0aa56f58e508a11546445aea9&stat=instructions:u) (up to 4.4% on `full` builds of `cranelift-codegen-opt`)
- Regression has unclear cause; left a nag for next week.

#### Nags requiring follow up

* [#78334](https://github.com/rust-lang/rust/pull/78334)
* [#77876](https://github.com/rust-lang/rust/pull/77876#issuecomment-717326989)
