# 2023-01-10 Triage Log

A very quiet week, with few changes in either direction, and none of significant magnitude.

Triage done by **@simulacrum**.
Revision range: [b435960c4cfd3975651c7051be56d7f5d6c201ab..0442fbabe24ec43636a80ad1f40a0ad92a2e38df](https://perf.rust-lang.org/?start=b435960c4cfd3975651c7051be56d7f5d6c201ab&end=0442fbabe24ec43636a80ad1f40a0ad92a2e38df&absolute=false&stat=instructions%3Au)

**Summary**:

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 1.2%  | [0.5%, 1.9%]   | 2     |
| Regressions ❌ <br /> (secondary)  | 1.1%  | [0.5%, 1.3%]   | 10    |
| Improvements ✅ <br /> (primary)   | -0.7% | [-1.2%, -0.5%] | 7     |
| Improvements ✅ <br /> (secondary) | -0.5% | [-0.7%, -0.2%] | 7     |
| All ❌✅ (primary)                 | -0.3% | [-1.2%, 1.9%]  | 9     |

1 Regressions, 1 Improvements, 3 Mixed; 1 of them in rollups
48 artifact comparisons made in total

#### Regressions

Rollup of 10 pull requests [#106573](https://github.com/rust-lang/rust/pull/106573) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=ee0412d1ef81efcfabe7f66cd21476ca85d618b1&end=e5d46a5bdac3f19793297914d4ada432024fbe95&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.3% | [0.2%, 0.3%] | 4     |
| Regressions ❌ <br /> (secondary)  | 0.5% | [0.3%, 1.0%] | 22    |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | 0.3% | [0.2%, 0.3%] | 4     |

Migrating rustc_infer to session diagnostics (part 3)
[#101936](https://github.com/rust-lang/rust/pull/101936) seems to be the cause
of the regression, but no investigation has happened yet.

#### Improvements

Remove duplicated elaborate box derefs pass [#106404](https://github.com/rust-lang/rust/pull/106404) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=14298997005486529e7a97b2ab9e9e376d6fdc72&end=e94fab69d020d75517cb55fafacb2d270ad6e0ac&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | 1.2%  | [1.2%, 1.2%]   | 2     |
| Improvements ✅ <br /> (primary)   | -     | -              | 0     |
| Improvements ✅ <br /> (secondary) | -0.3% | [-0.3%, -0.2%] | 7     |
| All ❌✅ (primary)                 | -     | -              | 0     |

Single regression is within noise range; improvements are not. Removing
perf-regression.

#### Mixed

Shrink `ParseResult` in the hot path. [#106416](https://github.com/rust-lang/rust/pull/106416) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=388538fc963e07a94e3fc3ac8948627fd2d28d29&end=b85f57d652a141b5c73f4f46b986a92b6992e9d9&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | 0.2%  | [0.2%, 0.2%]   | 1     |
| Improvements ✅ <br /> (primary)   | -0.4% | [-0.5%, -0.3%] | 7     |
| Improvements ✅ <br /> (secondary) | -0.4% | [-0.5%, -0.4%] | 4     |
| All ❌✅ (primary)                 | -0.4% | [-0.5%, -0.3%] | 7     |

Improvements include primary benchmarks and outweigh regressions.

Perform SimplifyLocals before ConstProp. [#105323](https://github.com/rust-lang/rust/pull/105323) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=a2112fcb0ad7327b9f1ee618c18567d74fc084b1&end=b1691f6413a4afd7529ab309965123cc63e82021&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.7%  | [0.2%, 1.6%]   | 4     |
| Regressions ❌ <br /> (secondary)  | 0.6%  | [0.6%, 0.6%]   | 1     |
| Improvements ✅ <br /> (primary)   | -0.6% | [-0.8%, -0.5%] | 4     |
| Improvements ✅ <br /> (secondary) | -0.5% | [-0.5%, -0.5%] | 1     |
| All ❌✅ (primary)                 | 0.0%  | [-0.8%, 1.6%]  | 8     |

Regressions did not occur in a pre-merge run, asked whether changes made after
it could have led to the regressions.

Don't normalize in AstConv [#101947](https://github.com/rust-lang/rust/pull/101947) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=89e0576bd3aec2f1acf935b353900bd75742860b&end=af58fc869910eae0ec525d49cbb6d953ea10a8c6&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.1%  | [0.1%, 0.1%]   | 1     |
| Regressions ❌ <br /> (secondary)  | 0.2%  | [0.2%, 0.2%]   | 3     |
| Improvements ✅ <br /> (primary)   | -1.0% | [-1.0%, -1.0%] | 1     |
| Improvements ✅ <br /> (secondary) | -0.8% | [-0.9%, -0.8%] | 7     |
| All ❌✅ (primary)                 | -0.5% | [-1.0%, 0.1%]  | 2     |
